<?php
session_start();
error_reporting(E_ALL);
ini_set('display_errors', 1);


if (!isset($_SESSION['config_login']) || $_SESSION['config_user'] != 'Admin') {
    echo '<script>window.location.href = "config.php";</script>';
    exit;
}

$user = $_SESSION['config_user'];

$isConfigFormSubmitted = false;
$isColorFormSubmitted = false;
$isimageFormSubmitted = false;

$configFileName = 'config.txt';
$colorFileName = 'color.txt';

// Read configuration from config.txt file
$configData = @file_get_contents($configFileName);

if ($configData !== false) {
    $configData = json_decode($configData, true);
} else {
    $configData = [];
}

// Extract values from the configuration
$environment = $configData['environment'] ?? 'production';
$brand_email = $configData['brand_email'] ?? '';
$brand_name = $configData['brand_name'] ?? '';
$brand_shortname = $configData['brand_shortname'] ?? '';
$brand_address = $configData['brand_address'] ?? '';
$brand_phone = $configData['brand_phone'] ?? '';
$enable_pay_on_delivery = $configData['enable_pay_on_delivery'] ?? false;
$enable_pay_now = $configData['enable_pay_now'] ?? false;
$centralized = $configData['CENTRALIZED'] ?? false;

// Read color data from color.txt file
$colorData = @file_get_contents($colorFileName);

if ($colorData !== false) {
    $colorData = json_decode($colorData, true);
} else {
    $colorData = [];
}

// Extract values from the color configuration
$mainColor = $colorData['mainColor'] ?? '#8e44ad';
$mainColor2 = $colorData['mainColor2'] ?? '#406ABF';

// Handle config form submission
if ($_SERVER['REQUEST_METHOD'] == 'POST' && isset($_POST['configFormSubmit'])) {

    // Retrieve form data
    $environment = $_POST['environment'];
    $brand_email = $_POST['brand_email'];
    $brand_name = $_POST['brand_name'];
    $brand_shortname = $_POST['brand_shortname'];
    $brand_address = $_POST['brand_address'];
    $brand_phone = $_POST['brand_phone'];
    $enable_pay_on_delivery = isset($_POST['enable_pay_on_delivery']) ? 'true' : 'false';
    $enable_pay_now = isset($_POST['enable_pay_now']) ? 'true' : 'false';
    $centralized = isset($_POST['centralized']) ? 'true' : 'false';

    // Create an array with configuration data
    $configData = [
        'environment' => $environment,
        'brand_email' => $brand_email,
        'brand_name' => $brand_name,
        'brand_shortname' => $brand_shortname,
        'brand_address' => $brand_address,
        'brand_phone' => $brand_phone,
        'enable_pay_on_delivery' => $enable_pay_on_delivery,
        'enable_pay_now' => $enable_pay_now,
        'CENTRALIZED' => $centralized,
    ];

    // Convert the array to JSON format
    $jsonConfig = json_encode($configData, JSON_PRETTY_PRINT);

    // Save the JSON data to the configuration file
    file_put_contents($configFileName, $jsonConfig);

    $isConfigFormSubmitted = true;
}

// Handle color form submission
if ($_SERVER['REQUEST_METHOD'] == 'POST' && isset($_POST['colorFormSubmit'])) {
    // Retrieve form data
    $mainColor = $_POST['mainColor'] ?? $mainColor;
    $mainColor2 = $_POST['mainColor2'] ?? $mainColor2;

    // Create an array with color data
    $colorData = [
        'mainColor' => $mainColor,
        'mainColor2' => $mainColor2,
    ];

    // Convert the array to JSON format
    $jsonColor = json_encode($colorData, JSON_PRETTY_PRINT);

    // Save the JSON data to the color.txt file
    file_put_contents($colorFileName, $jsonColor);

    $isColorFormSubmitted = true;
}



if ($_SERVER['REQUEST_METHOD'] == 'POST' && isset($_POST['imageFormSubmit'])) {
    if (isset($_FILES["file"])) {
        $targetDir = "img/";
        $targetFile = $targetDir . "logo.png";

        // Check if file already exists
        if (file_exists($targetFile)) {
            unlink($targetFile); // Delete existing file
        }

        // Move the uploaded file to the target directory
        if (move_uploaded_file($_FILES["file"]["tmp_name"], $targetFile)) {
            // File uploaded successfully
            $isimageFormSubmitted = true;
        } else {
            // Error uploading file
            $errorMessage = "Error uploading file.";
        }
    }
}






// Check if the form is submitted
if ($_SERVER["REQUEST_METHOD"] == "POST" && isset($_POST['logout_form'])) {
    // Unset the specified session variables
    unset($_SESSION['config_login']);
    unset($_SESSION['config_user']);

    // Redirect to config.php
    header("Location: config.php");
    exit();
}
?>

<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Update Configuration</title>
    <!-- Bootstrap CSS -->
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" rel="stylesheet">
</head>


<body>
    <nav class="navbar navbar-light bg-light ml-3 mr-2 justify-content-between">
        <a class="navbar-brand">
            <img src="img/vortex.png" alt="" height="50px">

        </a>

        <p style="color: #3434cb;"><?php echo $user; ?> logged in!</p>



        <form method="post" action="">

            <button class="btn btn-success my-2 my-sm-0" name="logout_form" type="submit">LOGOUT</button>
        </form>

    </nav>

    <div class="container mt-3">
        <h3 class="text-center mb-3"><u>Update Configuration</u></h3>

        <div class="row m-4 p-4">
            <!-- Config Form -->
            <div class="col-md-6" style="background-color: #eee;">
                <h2>Configurations</h2>
                <form method="post" action="">
                    <input type="hidden" name="configFormSubmit" value="1">

                    <div class="row">
                        <div class="col-md-6">
                            <div class="form-group">
                                <label for="environment">Environment:</label>
                                <select class="form-control" name="environment">
                                    <option value="development" <?php echo ($environment == 'development') ? 'selected' : ''; ?>>Development</option>
                                    <option value="production" <?php echo ($environment == 'production') ? 'selected' : ''; ?>>Production</option>
                                </select>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="form-group">
                                <label for="brand_email">Brand Email:</label>
                                <input type="text" class="form-control" name="brand_email" value="<?php echo $brand_email; ?>">
                            </div>
                        </div>


                    </div>


                    <div class="row">
                        <div class="col-md-6">
                            <div class="form-group">
                                <label for="brand_name">Brand Name:</label>
                                <input type="text" class="form-control" name="brand_name" value="<?php echo $brand_name; ?>">
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="form-group">
                                <label for="brand_shortname">Brand Short Name:</label>
                                <input type="text" class="form-control" name="brand_shortname" value="<?php echo $brand_shortname; ?>">
                            </div>
                        </div>
                    </div>


                    <div class="row">
                        <div class="col-md-6">
                            <div class="form-group">
                                <label for="brand_address">Brand Address:</label>
                                <input type="text" class="form-control" name="brand_address" value="<?php echo $brand_address; ?>">
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="form-group">
                                <label for="brand_phone">Brand Phone:</label>
                                <input type="text" class="form-control" name="brand_phone" value="<?php echo $brand_phone; ?>">
                            </div>
                        </div>
                    </div>

                    <div class="form-check">
                        <input type="checkbox" class="form-check-input" name="enable_pay_on_delivery" <?php echo ($configData['enable_pay_on_delivery'] === 'true') ? 'checked' : ''; ?>>
                        <label class="form-check-label" for="enable_pay_on_delivery">Enable Pay on Delivery</label>
                    </div>

                    <div class="form-check">
                        <input type="checkbox" class="form-check-input" name="enable_pay_now" <?php echo ($configData['enable_pay_now'] === 'true') ? 'checked' : ''; ?>>
                        <label class="form-check-label" for="enable_pay_now">Enable Pay Now</label>
                    </div>

                    <div class="form-check">
                        <input type="checkbox" class="form-check-input" name="centralized" <?php echo ($configData['CENTRALIZED'] === 'true') ? 'checked' : ''; ?>>
                        <label class="form-check-label" for="centralized">Centralized</label>
                    </div>
                    <button type="submit" class="btn btn-primary mt-3">Update Configuration</button>
                </form>
                <?php if ($isConfigFormSubmitted) : ?>
                    <div class="alert alert-success mt-3" role="alert">
                        Configuration Updated Successfully!
                    </div>
                <?php endif; ?>
            </div>


            <!-- Color Form -->
            <div class="col-md-6" style="background-color: #eef;">
                <h2>Colors</h2>
                <form method="post" action="">
                    <input type="hidden" name="colorFormSubmit" value="1">
                    <!-- Color Form Fields -->
                    <div class="form-group">
                        <label for="mainColor">Primary Color:</label>
                        <input type="color" id="mainColor" name="mainColor" class="form-control" value="<?= $mainColor; ?>">
                    </div>
                    <div class="form-group">
                        <label for="mainColor2">Secondary Color:</label>
                        <input type="color" id="mainColor2" name="mainColor2" class="form-control" value="<?= $mainColor2; ?>">
                    </div>
                    <button type="submit" class="btn btn-primary mt-3">Update Colors</button>
                </form>
                <?php if ($isColorFormSubmitted) : ?>
                    <div class="alert alert-success mt-3" role="alert">
                        Colors Updated Successfully!
                    </div>
                <?php endif; ?>
            </div>


            <div class="col-md-6 mt-4" style="background-color: #E1FBF7;">
                <h2>Brand Logo</h2>

                <img src="img/logo.png" class="mb-2" alt="Brand Logo">

                <form action="" method="post" enctype="multipart/form-data">
                    <input type="hidden" name="imageFormSubmit" value="1">

                    <label for="fileInput">Choose a PNG file (213px x 90px):</label>
                    <input type="file" id="fileInput" name="file" accept=".png" onchange="validateFile()">
                    <br>
                    <button type="submit" id="submitButton" class="btn btn-primary mt-3" disabled>Update Logo</button>
                </form>
                <?php if ($isimageFormSubmitted) : ?>
                    <div class="alert alert-success mt-3" role="alert">
                        Brand Logo Updated Successfully!
                    </div>
                <?php endif; ?>
            </div>

        </div>
    </div>
    <!-- Bootstrap JS -->
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- SweetAlert JS -->
    <script src="https://cdn.jsdelivr.net/npm/sweetalert2@10"></script>



    <script>
        $(document).ready(function() {
            // Check if the form was submitted
            var isFormSubmitted = <?php echo json_encode($isConfigFormSubmitted); ?>;

            var isFormSubmitted2 = <?php echo json_encode($isColorFormSubmitted); ?>;
            var isFormSubmitted3 = <?php echo json_encode($isimageFormSubmitted); ?>;


            if (isFormSubmitted) {
                // Show SweetAlert
                Swal.fire({
                    icon: 'success',
                    title: 'Configuration Updated',
                    text: 'Your configuration has been updated successfully!',
                }).then((result) => {
                    // Redirect after the SweetAlert is closed
                    window.location.href = 'admin_update_config.php';
                });
            }

            if (isFormSubmitted2) {
                // Show SweetAlert
                Swal.fire({
                    icon: 'success',
                    title: 'Colors Updated',
                    text: 'Colors Updated Successfully!!',
                }).then((result) => {
                    // Redirect after the SweetAlert is closed
                    window.location.href = 'admin_update_config.php';
                });
            }

            if (isFormSubmitted3) {
                // Show SweetAlert
                Swal.fire({
                    icon: 'success',
                    title: 'Image Updated',
                    text: 'Brand Logo has been updated successfully!',
                }).then((result) => {
                    // Redirect after the SweetAlert is closed
                    window.location.href = 'admin_update_config.php';
                });
            }



        });

        function validateFile() {
            var fileInput = document.getElementById('fileInput');
            var submitButton = document.getElementById('submitButton');
            var allowedTypes = ['image/png'];
            var maxWidth = 213;
            var maxHeight = 90;

            if (fileInput.files.length > 0) {
                var file = fileInput.files[0];

                // Check file type
                if (!allowedTypes.includes(file.type)) {
                    Swal.fire({
                        icon: 'error',
                        title: 'Error Selecting File',
                        text: 'Please select a PNG file.',
                    });
                    fileInput.value = '';
                    submitButton.disabled = true;
                    return;
                }

                // Check dimensions
                var img = new Image();
                img.src = window.URL.createObjectURL(file);
                img.onload = function() {
                    if (img.width === maxWidth && img.height === maxHeight) {
                        submitButton.disabled = false;
                    } else {
                        Swal.fire({
                            icon: 'error',
                            title: 'Error Selecting File',
                            text: 'Logo dimensions must be 213px x 90px.',
                        });
                        fileInput.value = '';
                        submitButton.disabled = true;
                    }
                };
            }
        }
    </script>

</html>