<?php include "includes/header.php";


//check if user session is set else 

if(isset($_SESSION['user'])){

    $mobile = $_SESSION['user']['Number'];
    $id = $_SESSION['user']['ID'];

}else{
    include "check_login.php";
}


?>

<!--  jQuery -->
<script src="https://code.jquery.com/jquery-3.6.4.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/toastr.min.js" integrity="sha512-VEd+nq25CkR676O+pLBnDW09R7VQX9Mdiij052gVCp5yVH3jGtH70Ho/UUv4mJDsEdTvqRCFZg0NKGiojGnUCw==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
<!--  SweetAlert library -->
<script src="https://cdn.jsdelivr.net/npm/sweetalert2@11"></script>

<script>
    toastr.options = {
        "closeButton": true,
        "newestOnTop": false,
        "progressBar": true,
        "positionClass": "toast-bottom-full-width",
        "preventDuplicates": false,
        "onclick": null,
        "showDuration": "300",
        "hideDuration": "1000",
        "timeOut": "5000",
        "extendedTimeOut": "1000",
        "showEasing": "swing",
        "hideEasing": "linear",
        "showMethod": "fadeIn",
        "hideMethod": "fadeOut"
    }
</script>

<style>
    select {
        display: block !important;
        width: 100% !important;
    }

    #loading-spinner {
        text-align: center;
        padding: 20px;
    }
</style>



<body>



    <section class="vh-100 d-flex justify-content-center align-items-center card-bg">
        <div class="col-12 col-md-8 col-lg-6 col-xl-5">
            <div class="card">
                <div class="card-body p-4 text-center">
                    <div class="mb-md-3 pb-3">
                        <form>

                            <img src="./img/logo.png" class="mb-0" alt="Profile Image" width="300">

                            <h3 class="fw-bold mb-4 text-uppercase">Select Branch</h3>

                            <!--  loading spinner -->
                            <div id="loading-spinner" style="display: block; text-align: center; padding: 20px;">
                                <div class="spinner-border" role="status">
                                    <span class="visually-hidden"></span>
                                </div>

                            </div>




                            <div class="d-flex justify-content-center align-items-center mb-4">
                                <div style="width: 80%;">
                                    <div class="form-outline form-dark mb-3">

                                        <select id="branch" name="branchid" class="form-select">

                                        </select>
                                    </div>
                                </div>
                            </div>

                            <input type="hidden" name="phone" value="<?php echo $mobile; ?>">
                            <input type="hidden" name="id" value="<?php echo $id; ?>">

                            <button class="btn btn-lg btn-main" id="submitBtn" type="submit">SUBMIT</button>
                        </form>
                    </div>

                    <div>
                        <p class="mb-0">
                            <a class="link" href="index.php">
                                back</a>
                        </p>
                    </div>
                </div>
            </div>
        </div>
    </section>

    <script>
        function disableButton() {
            // Disable the button
            var submitBtn = document.getElementById("submitBtn");
            submitBtn.disabled = true;
            // Change background color to gray
            submitBtn.classList.add('btn-load');
            // Change the button text
            submitBtn.innerHTML = 'Processing...';


        }

        function enableButton() {
            // enable the button
            var submitBtn = document.getElementById("submitBtn");
            submitBtn.disabled = false;
            // Change background color to gray
            submitBtn.classList.remove('btn-load');
            submitBtn.classList.add('btn-main');
            // Change the button text
            submitBtn.innerHTML = 'SUBMIT';
        }

        $(document).ready(function() {

            fetchbraches();


            // Submit the form using jQuery
            $('form').submit(function(event) {
                event.preventDefault();

                // Get form data
                var formData = $(this).serialize();

                disableButton();
                var mobile = <?php echo json_encode($_GET['mobile']); ?>;


                // Make an AJAX request to the server
                $.ajax({
                    type: 'POST',
                    url: 'functions/updatebranch.php',
                    data: formData,
                    dataType: 'json',
                    success: function(response) {
                        // Show toastr based on the response
                        if (response.success) {
                          

                           toastr.success(response.message);

                            
                            getUserData(mobile)

                        } else {

                            toastr.error(response.message);
                            enableButton();

                        }
                    },
                    error: function() {
                        Swal.fire({
                            title: 'Error',
                            text: 'An error occurred while processing your request.Please try again',
                            icon: 'error',
                        }).then((result) => {
                            enableButton()

                        });
                    }
                });


            });
        });




        function getUserData(mobile) {
           
           $.ajax({
               type: 'POST',
               url: 'functions/profile.php',
               data: {
                   mobile: mobile
               },
               dataType: 'json',
               success: function(response) {
                
                   window.location.href = 'index.php';

               },
               error: function() {
                   window.location.href = 'login.php';
                   
               }
           });
       }



        //fetch data
        function fetchbraches() {
            disableButton();

            var fetchCartUrl = 'functions/branch.php';

            $.ajax({
                type: 'GET',
                url: fetchCartUrl,
                dataType: 'json',
                success: function(data) {
                    enableButton();

                    // Update the cart items on success
                    if (data.length > 0) {
                        // If the branches is not empty, update the branch items
                        updateBranchesData(data);


                        $('#loading-spinner').hide();


                    } else {

                        $('#loading-spinner').hide();


                    }


                },
                error: function(error) {
                   
                    enableButton();
                }
            });
        }


        function updateBranchesData(data) {
            var select = $('#branch');
            select.empty(); // Clear existing options

            // Populate the select element with branch data
            $.each(data, function(index, branch) {
                select.append($('<option>', {
                    value: branch.ID,
                    text: branch.Name
                }));
            });
        }
    </script>

</body>

</html>